/* fir-tools/src/fir2csv/800_fir2csv.c
 *
 *  Copyright: ©2014, Laurence Withers
 *  Author: Laurence Withers <l@lwithers.me.uk>
 *  License: GPLv3
 */



char csv_sep = ',';



void
fir2csv(struct fir_filter_t* fi, int num_points, FILE* fp)
{
    double complex resp;
    int i;
    double freq, mag, phase, phase_unwrap, phase_last;

    fprintf(fp, "Frequency%cMagnitude%cMagnitude_dB%cPhase%cPhase_unwrapped%c"
        "Group_delay\n",
        csv_sep, csv_sep, csv_sep, csv_sep, csv_sep);

    for(i = 0; i < num_points; ++i) {
        freq = (i * 0.5) / (num_points - 1);
        resp = fir_filter_response(fi, freq);

        fprintf(fp, "%.8g%c", freq, csv_sep);

        mag = cabs(resp);
        fprintf(fp, "%.8g%c", mag, csv_sep);
        fprintf(fp, "%.4g%c", 20 * log10(mag), csv_sep);

        phase = carg(resp);
        fprintf(fp, "%.8g%c", phase, csv_sep);
        if(i) {
            if((phase - phase_last) > M_PI) {
                phase_unwrap -= 2 * M_PI;
            } else if((phase - phase_last) < -M_PI) {
                phase_unwrap += 2 * M_PI;
            }
            phase_last = phase;
            phase += phase_unwrap;
        }
        fprintf(fp, "%.8g%c", phase, csv_sep);
        if(i) {
            fprintf(fp, "%.8g\n", phase / freq / (2 * M_PI));
        } else {
            fputs("0\n", fp);
        }
    }
}



/* options for text editors
vim: expandtab:ts=4:sw=4
*/
