# These are external variables, and shouldn't clash with anything else
#  fir2csv
#  fir2csv_BUILT
#

if [ -z ${fir2csv_BUILT} ]
then
    fir2csv="obj/fir2csv"
    EXTRAS="-std=gnu99 -D_GNU_SOURCE -DAPP_NAME=\"fir2csv\" -lm \
        ${LIBFIR_CFLAGS} ${LIBFIR_LIBS}"

    echo "Building application ${fir2csv}..."

    do_cmd source src/fir2csv/build.monolithic || return 1

    MODIFIED=0
    for test in ${MONOLITHIC_TESTS} ${SRC}
    do
        if [ ${test} -nt ${fir2csv} ]
        then
            MODIFIED=1
            break
        fi
    done

    if [ ${MODIFIED} -ne 0 ]
    then
        echo " Compiling..."

        do_cmd ${CC} ${CFLAGS} -I obj -o "${fir2csv}" ${SRC} ${EXTRAS} || return 1

        print_success "Application built"
    else
        print_success "Application up to date"
    fi

    fir2csv_BUILT=1

fi

# vim: syntax=sh:expandtab:ts=4:sw=4
